#ifndef KEYFLOW_BIRDCARREAU_H
#define KEYFLOW_BIRDCARREAU_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <string>

#include "function1.h"



namespace keyFlow {
  
  using namespace keyFE2 ;
  
  class BirdCarreau : public function1 {
    
    protected :
      
      Double eta0 ;
      Double lambda0 ;
      Double expo ;
      
      Int orderDeriv ;
    
    public :
      
      BirdCarreau(Double argEta0=1.0,Double argLambda0=1.0,
		  Double argExpo=1.0);
      BirdCarreau(const BirdCarreau &in);
      ~BirdCarreau(void);
      
      Double value(Double) const ;
      Double deriv(Double) const ;
      
      void setArgEta0(Double);
      Double getArgEta0(void) const ;
      void setArgLambda0(Double);
      Double getArgLambda0(void) const ;
      void setArgExpo(Double);
      Double getArgExpo(void) const ;
      
      function1* makeCopy(void) const ;
      
      function1* makeFunctionDeriv(void) const ;
      
      std::string strPrint(void) const ;

  } ;
  
}

#endif
