#ifndef ARRAY_FUNCTIONS_BUILD_H
#define ARRAY_FUNCTIONS_BUILD_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include "types/allTypes.h"
#include "util/utils.h"

#include "array_base.h"
#include "arrayOp1.h"
#include "arrayOp2.h"

//class globLoc ;
//class tensorCoordSys ;

namespace keyFE2 {
  
  // Building of the various monadic operators :
  
  arrayOp1* transpositionBuild(array &arg,Int index1,Int index2) ;
  arrayOp1* contractionBuild(array &arg,Int index1,Int index2) ;
  arrayOp1* inversionBuild(array &arg) ;
  arrayOp1* functionBuild(array &arg,function1 *F) ;
  arrayOp1* indicesPermutationBuild(array &arg) ;
  arrayOp1* discretizedTranspositionBuild(array &arg) ;
  
  // Building of the various dyadic functions :
  
  arrayOp2* vectProductBuild(array* first,array *second) ;
  arrayOp2* specialContractBuild(array *arrayArg1,array *arrayArg2,
				 Int indexMax) ;
  arrayOp2* additionBuild(array* first,array *second) ;
  arrayOp2* soustractionBuild(array* first,array *second) ;
  arrayOp2* exteriorMultiplicationBuild(array *first,array *second) ;
  arrayOp2* contractedMultiplicationBuild(array *first,Int index1,
					  array *second,Int index2) ;
  arrayOp2* accumulationBuild(array* first,array *second,Int) ;
  arrayOp2* substitutionBuild(array* first,array *second,Int,Int) ;
  
  // Building of "arrayOpN" type arrays arrays :
  
  bool specialCombiliNeeded(array *arg1,array *arg2) ;
  arrayOpN* specialCombiliBuild(Double fact1,array *arg1,Double fact2,
				array *arg2) ;
  arrayOpN* upwindF(array *V,array *rho,array *k,array *testU,array *dXdt,
                    globLoc *gl,Double dInterp) ;
  
}

#endif


