#ifndef CONSTR_BASE_H
#define CONSTR_BASE_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include "expr/exprCollect.h"
#include "print/print.h"
#include "types/types.h"
#include "util/name.h"
#include "util/parents.h"

namespace keyFE2 {
  
  class constr : public virtual name, public virtual parents,
                 public virtual print {
					
    friend class solver ;
    
    protected :
      
      Int layer ;
      exprCollect EC ;
      friend void constr1_test1(void) ;
    
    public :
      
      constr(void) ;
      constr(const constr &in) ;
      virtual ~constr(void) ;
    
      void operator=(const constr &in) ;
      
      void setLayer(Int nbr) ;
      Int getLayer(void) const ;
    
      virtual void generateExprCollect(bool makeValue=true,
				       bool makeDeriv=true) ;
      void resolveExprCollect(void) ;
      const exprCollect & getExprCollect(void) const ;
    
      virtual printTree getPrintTreeData(void) const ;
      virtual printTree getPrintTree(void) const ;
      virtual printTree getPrintTreeSummary(void) const ;

   } ;
  
}

#endif




