
//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <string.h>
#include <stdio.h>
#include <iostream>
#include <iomanip>

#include "err.h"

using namespace std ;
using namespace keyFE2 ;



bool err::Ok=true;



err::err(void) {
  functionName="";
  fileName="";
  lineNumber=0;
  message="";
}



err::err(string fuName,string fiName,int liNumber,string msg) {
  functionName=fuName;
  fileName=fiName;
  lineNumber=liNumber;
  message=msg;
}



err::err(string fiName,int liNumber,string msg) {
  functionName="";
  fileName=fiName;
  lineNumber=liNumber;
  message=msg;
}



err::err(const err &in) {
  functionName=in.functionName;
  fileName=in.fileName;
  lineNumber=in.lineNumber;
  message=in.message;
}



err::~err(void) {
  functionName="";
  fileName="";
  lineNumber=0;
  message="";  
}



void err::write(ostream &out) const {
  if (lineNumber!=0) {
    if (functionName!="")
      out << "Error in function " << functionName 
	<< " (" << fileName << ":"
	  << lineNumber << ") :" << endl ;
    else
      out << "Error in file " << fileName 
	<< ":" << lineNumber << " :" << endl ;
    out << "   " << message << endl ;
  }
}



void err::exec(ostream &out) {
  write(out);
}



void err::exec(void) {
  write(cerr);
}



void err::setOk(bool b) {
  Ok=b;
}



bool err::getOk(void) {
  return Ok;
}
