#ifndef EXPRCOLLECT_H
#define EXPRCOLLECT_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <iostream>

#include "types/types.h"

namespace keyFE2 {
  
  class expression ;
  
  // One assumes that all expressions are sorted by increasing index order.
  
  class exprCollect {
    
    friend class constr ;
    friend class solver ;
    
    private :
      
      Int capacity ;
      Int size ;
      expression *exprData ;
    
    public :
      
      exprCollect(void) ;
      exprCollect(const exprCollect &in) ;
      ~exprCollect(void) ;
      
      void operator=(const exprCollect &arg) ;
      
      void clear(void) ;
      Int getSize(void) const ;
      void setCapacity(Int nbr) ;
      void pushBack(const expression &arg) ;
      
      void setLayer(Int nbr) ;
      
      void merge(const exprCollect &left,const exprCollect &right) ;
      Int getPosFromIndex(Int nbr) ;
      void solve(void) ;
      
      void write(std::ostream &os) const ;
      
  } ;
  
}

#endif
