#ifndef DPOWMULT_H
#define DPOWMULT_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include "function1.h"

namespace keyFE2 {
  
  class DPowMult : public function1 {
    
    protected :
      
      Double DParam1;
      Double DParam2;
    
    public :
      
      DPowMult(void);
      DPowMult(Double factor=1.0,Double exponent=1.0);
      DPowMult(const DPowMult &in);
      ~DPowMult(void);
      
      Double value(Double) const ;
      Double deriv(Double) const ;
      
      void setDParam1(Double);
      Double getDParam1(void) const ;
      void setDParam2(Double);
      Double getDParam2(void) const ;
      
      function1* makeCopy(void) const ;
      
      function1* makeFunctionDeriv(void) const ;
      
      std::string strPrint(void) const ;

  } ;
  
}

#endif
