#ifndef Dpw_LINEAR_4_H
#define Dpw_LINEAR_4_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include "function1.h"

namespace keyFE2 {
  
  class DpwLinear4 : public function1 {
    
    protected :
      
      Double PA;
      Double X1;
      Double Y1;
      Double X2;
      Double Y2;
      Double X3;
      Double Y3;
      Double X4;
      Double Y4;
      Double PB;
    
    public :
      
      DpwLinear4(void);
      DpwLinear4(Double pa,
                 Double x1,Double y1,
                 Double x2,Double y2,
                 Double x3,Double y3,
                 Double x4,Double y4,
                 Double pb);
      DpwLinear4(const DpwLinear4 &in);
      ~DpwLinear4(void);
      
      Double value(Double) const ;
      Double deriv(Double) const ;
      
      void setPA(Double);
      Double getPA(void) const ;
      void setX1(Double);
      Double getX1(void) const ;
      void setY1(Double);
      Double getY1(void) const ;
      void setX2(Double);
      Double getX2(void) const ;
      void setY2(Double);
      Double getY2(void) const ;
      void setX3(Double);
      Double getX3(void) const ;
      void setY3(Double);
      Double getY3(void) const ;
      void setX4(Double);
      Double getX4(void) const ;
      void setY4(Double);
      Double getY4(void) const ;
      void setPB(Double);
      Double getPB(void) const ;
      
      function1* makeCopy(void) const ;
      
      function1* makeFunctionDeriv(void) const ;
      
      std::string strPrint(void) const ;

  } ;
  
}

#endif
