
//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <cstdlib>
#include <iomanip>
#include <iostream>
#include <string>

#include "function1.h"
#include "err/err.h"

using namespace std ;
using namespace keyFE2 ;



bool function1::dynamicallyAllocated=false;



function1::function1(void) : parents() {
  if (!dynamicallyAllocated)
    parents::addParent(&dynamicallyAllocated);
  dynamicallyAllocated=false;
}



function1::~function1(void) {
}



void* function1::operator new(size_t s) {
  static void *p;
  dynamicallyAllocated=true;
  p=malloc(s) ;
  return p ;
}



void function1::operator delete(void *p) {
  free(p);
}



void* function1::operator new[](size_t s) {
  errThrow("function1::operator new[]","Forbidden operator");
  static void *p;
  dynamicallyAllocated=true;
  p=malloc(s) ;
  return p ;
}



void function1::operator delete[](void *p) {
  errThrow("function1::operator delete[]","Forbidden operator");
}



Double function1::value(Double arg) const {
  errThrow("function1::value",
	   "cannot use the generic function1 type to get a function value.");
}



Double function1::deriv(Double arg) const {
  errThrow("function1::deriv",
	   "cannot use the generic function1 type to get a function derivative.");
}



function1* function1::makeCopy(void) const {
  errThrow("function1::makeCopy",
	   "cannot make a copy of base function1 object.");
}



function1* function1::makeFunctionDeriv(void) const {
  errThrow("function1::makeFunctionDeriv",
	   "cannot make a derivative function of function1 object.");
}



string function1::strPrint(void) const {
  string str="unknown function1";
  return str;
}


