
//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <typeinfo>
#include <iostream>
#include <iomanip>

#include "Object.h"
#include "object_base.h"

#include "err/err.h"

using namespace std ;
using namespace keyFE2 ;



Object::Object(void) {
  try {
    data=NULL;
    direct=-1000;
  }
  catchAll("Object::Object(void)","at the very end")
}



Object::Object(const Object &in) {
  try {
    data=NULL;
    setData(in.getData());
    setDirect(in.getDirect());
  }
  catchAll("Object::Object(const Object &in)","at the very end")  
}



Object::~Object(void) {
  try {
    setData(NULL);
    direct=-1000;
  }
  catchAll("Object::~Object(void)","at the very end")
}



void Object::setData(object *newObjectData) {
  try{
    data=static_cast<void*>(newObjectData);
  }
  catchAll("Object::setData","at the very end")  
}



object* Object::getData(void) const {
  try{
    return(static_cast<object*>(data));
  }
  catchAll("Object::getData","at the very end")  
}



void Object::setDirect(Int newObjectDirect) {
  try{
    direct=newObjectDirect;
  }
  catchAll("Object::setDirect","at the very end")  
}



Int Object::getDirect(void) const {
  try{
    return(direct);
  }
  catchAll("Object::getDirect","at the very end")  
}



Int Object::getType(void) const {
  try{
    return(getData()->getType());
  }
  catchAll("Object::getType","at the very end")  
}
      


string Object::getTypeName(void) const {
  try{
    return(getData()->getTypeName());
  }
  catchAll("Object::getTypeName","at the very end")  
}
      


Int Object::getDim(void) const {
  try{
    return(getData()->getDim());
  }
  catchAll("Object::getDim","at the very end")  
}
      
