#ifndef SHAPE_H
#define SHAPE_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <string>

#include "types/types.h"
#include "types/params.h"

namespace keyFE2 {
  
  class object ;
  class domain ;
  
  class shape {
    
    protected :
      
    public :
      
      static Int interpolationType(std::string interpolationTypeName);
      static std::string interpolationTypeName(Int interpolationType);
    
      static Int getSpecificNVnbr(object*,Int interpolationType,
				  domain *dom=NULL);
      static Int getSpecificNVPermutation(object*,Int interpolationType,
					  Int thisDirect,Int *permutation,
					  domain *dom=NULL);
    
      static Int oneDimSF(const Int &interpType,Double &xi,Double *F,
			  Int orderDeriv=0);
      static Int function(const Int &interpType,const Int &objectType,
			  domain *defDomain,Double coord[3],
			  Int corlocDeriv[3],Double *F);
      static Int nbrFunctions(const Int &interpType,const Int &objectType);
    
  } ;
  
}

#endif



