
//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <fstream>
#include <iomanip>

#include "test.h"
#include "domain/Domain.h"
#include "field/Field.h"
#include "mesh/Mesh.h"
#include "param/paramList.h"

using namespace std ;
using namespace keyFE2 ;



namespace keyFE2 {
  
  void domain_test1(void) {
    Mesh MESH;
    Domain dom,bnd,brol;
    
    MESH.read("brol.msh","rsMesh");
    
    for (int i=0;i<10;i++) {
      dom=MESH.getDomain(1);
      brol=MESH.getDefDomain();
      
      Field f((DOM=dom,INTERPOLATION="linear",NBRCOMPONENTS=2,
	       COMPONENTNAME(0)="X",COMPONENTNAME(1)="Y",
	       NAME="coordinates",INTERPMESH=MESH));
      Field f4((DOM=dom,INTERPOLATION="quadratic",NBRCOMPONENTS=3,
		COMPONENTNAME(0)="X"));
      Field f5((DOM=dom));
      Field f6((DOM=dom,INTERPOLATION="linear",NBRCOMPONENTS=3));
      Field f7((DOM=dom,INTERPOLATION="constantPerElement",NBRCOMPONENTS=3));
      
      dom.setName("brol");
      bnd=dom.getBoundary();
      
      ofstream outFile("domain1.lst");
      brol.write(outFile);
      brol.writeValues(outFile);
      dom.splitWrite(outFile);
      bnd.write(outFile);
      bnd.splitWrite(outFile);
      
      f5=f4;
    }  
  }
  
}











