
//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <fstream>
#include <iomanip>

#include "test.h"
#include "domain/Domain.h"
#include "mesh/Mesh.h"
#include "field/Field.h"
#include "object/object_base.h"
#include "param/paramList.h"

using namespace std ;
using namespace keyFE2 ;



namespace keyFE2 {
  
  void interp_test1(void) {
    Mesh MESH;
    Domain defdom,firstdom;
    
    MESH.read("brol.msh","rsMesh");
    
    firstdom=MESH.getDomain(1);
    defdom=MESH.getDefDomain();
    
    Field velo((DOM=defdom,INTERPOLATION="quadratic",NBRCOMPONENTS=2,
		COMPONENTNAME(0)="u",COMPONENTNAME(1)="v",
		NAME="velocities"));
    Field coord((DOM=firstdom,INTERPOLATION="linear",NBRCOMPONENTS=2,
		 COMPONENTNAME(0)="X",COMPONENTNAME(1)="Y",
		 NAME="coordinates",INTERPMESH=MESH));
    velo.interpolate(coord,firstdom,coord);
  }
  
  
  
  void interp_test2(void) {
    Mesh MESH;
    Domain defdom;
    
    MESH.read("oneQuad.msh","rsMesh");
    
    defdom=MESH.getDefDomain();
    
    Field velo((DOM=defdom,INTERPOLATION="quadratic",NBRCOMPONENTS=2,
		COMPONENTNAME(0)="u",COMPONENTNAME(1)="v",
		NAME="velocities"));
    Field coord((DOM=defdom,INTERPOLATION="linear",NBRCOMPONENTS=2,
		 COMPONENTNAME(0)="X",COMPONENTNAME(1)="Y",
		 NAME="coordinates",INTERPMESH=MESH));
    velo.interpolate(coord,defdom,coord);
  }
  
  
  
  void interp_test3(void) {
    Mesh MESH;
    Domain defdom,firstdom;
    
    MESH.read("brol.msh","rsMesh");
    
    firstdom=MESH.getDomain(1);
    defdom=MESH.getDefDomain();
    
    Field velo((DOM=defdom,INTERPOLATION="quadratic",NBRCOMPONENTS=2,
		COMPONENTNAME(0)="u",COMPONENTNAME(1)="v",
		NAME="velocities"));
    Field coord((DOM=defdom,INTERPOLATION="linear",NBRCOMPONENTS=2,
		 COMPONENTNAME(0)="X",COMPONENTNAME(1)="Y",
		 NAME="coordinates",INTERPMESH=MESH));
    velo.interpolate(coord,firstdom,coord);
  }
  
}





