#ifndef UTILS_H
#define UTILS_H

//
//  Copyright 2004 Renaud Sizaire
//
//  This file is part of keyFE2.
//
//  keyFE2 is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  keyFE2 is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with keyFE2; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#include <cmath>
#include <string>

#include "util/name.h"
#include "util/newPoint.h"
#include "util/parents.h"
#include "util/boolZero.h"

inline Int min(Int a,Int b) {
  return (a<b) ? a : b ;
}

inline Int min(Int a,Int b,Int c) {
  static Int tmp;
  tmp=min(a,b);
  return (tmp<c) ? tmp : c ;
}

inline Int max(Int a,Int b) {
  return (a<b) ? b : a ;
}

inline Int max(Int a,Int b,Int c) {
  static Int tmp;
  tmp=max(a,b);
  return (tmp<c) ? c : tmp ;
}

inline Double min(Double a,Double b) {
  return (a>b) ? b : a ;
}

inline Double max(Double a,Double b) {
  return (a<b) ? b : a ;
}

std::string strFromInt(Int a) ;

std::string strFromDouble(Double a) ;

#endif

